Index: /branches/2936_GQAPIntegration/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs
===================================================================
--- /branches/2936_GQAPIntegration/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs	(revision 16710)
+++ /branches/2936_GQAPIntegration/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs	(revision 16711)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,4 +31,5 @@
 using System.Text.RegularExpressions;
 using System.Threading.Tasks;
+using HEAL.Attic;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
 using HeuristicLab.Persistence.Auxiliary;
@@ -43,8 +44,9 @@
 using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
+using Serializer = HeuristicLab.Persistence.Core.Serializer;
 
 namespace HeuristicLab.Persistence.Tests {
 
-  [StorableClass]
+  [StorableType("25A94A36-F3AA-4207-A3C9-54260D2A1724")]
   public class NumberTest {
     [Storable]
@@ -93,20 +95,21 @@
         _ulong.GetHashCode();
     }
+
+    [StorableConstructor]
+    protected NumberTest(StorableConstructorFlag _) {
+    }
+    public NumberTest() {
+    }
   }
 
-  [StorableClass]
-  public class NonDefaultConstructorClass {
-    [Storable]
-    int value;
-    public NonDefaultConstructorClass(int value) {
-      this.value = value;
-    }
-  }
-
-  [StorableClass]
+  [StorableType("BE44EB33-C8B7-4CDA-A564-3165558FEBE7")]
   public class IntWrapper {
 
     [Storable]
     public int Value;
+
+    [StorableConstructor]
+    protected IntWrapper(StorableConstructorFlag _) {
+    }
 
     private IntWrapper() { }
@@ -127,5 +130,5 @@
   }
 
-  [StorableClass]
+  [StorableType("A7865A50-E5B7-4656-8648-F375FC678BA3")]
   public class PrimitivesTest : NumberTest {
     [Storable]
@@ -155,9 +158,16 @@
         o.GetHashCode();
     }
+
+    [StorableConstructor]
+    protected PrimitivesTest(StorableConstructorFlag _) : base(_) {
+    }
+    public PrimitivesTest() {
+    }
   }
 
-  public enum TestEnum { va1, va2, va3, va8 } ;
-
-  [StorableClass]
+  [StorableType("18245FB6-D650-4378-9197-CCE6BB678F66")]
+  public enum TestEnum { va1, va2, va3, va8 };
+
+  [StorableType("F5646F6C-DCD3-47D7-BBE5-2B33812B06D7")]
   public class RootBase {
     [Storable]
@@ -176,7 +186,13 @@
         myEnum.GetHashCode();
     }
+
+    [StorableConstructor]
+    protected RootBase(StorableConstructorFlag _) {
+    }
+    public RootBase() {
+    }
   }
 
-  [StorableClass]
+  [StorableType("A9F5AFC4-20D3-4898-A7B6-E78A2CCE343B")]
   public class Root : RootBase {
     [Storable]
@@ -206,4 +222,10 @@
     [Storable(DefaultValue = "default")]
     public string uninitialized;
+
+    [StorableConstructor]
+    protected Root(StorableConstructorFlag _) : base(_) {
+    }
+    public Root() {
+    }
   }
 
@@ -213,5 +235,5 @@
   public enum TrickyEnum { zero = 0, one = 1, two = 2 }
 
-  [StorableClass]
+  [StorableType("969350FD-1E94-4A6F-BA95-6D2D48014E73")]
   public class EnumTest {
     [Storable]
@@ -221,7 +243,13 @@
     [Storable]
     public TrickyEnum trickyEnum = (TrickyEnum)15;
+
+    [StorableConstructor]
+    protected EnumTest(StorableConstructorFlag _) {
+    }
+    public EnumTest() {
+    }
   }
 
-  [StorableClass]
+  [StorableType("03CC855E-1DCA-451E-9BFB-3B06E7F96CAA")]
   public class Custom {
     [Storable]
@@ -231,7 +259,15 @@
     [Storable]
     public string name = "<![CDATA[<![CDATA[Serial]]>]]>";
+
+    [StorableConstructor]
+    protected Custom(StorableConstructorFlag _) {
+    }
+
+    public Custom() {
+
+    }
   }
 
-  [StorableClass]
+  [StorableType("C3A632A5-F356-4E22-8659-BBE515638CDC")]
   public class Manager {
 
@@ -244,7 +280,13 @@
     [Storable]
     public double? dbl;
+
+    [StorableConstructor]
+    protected Manager(StorableConstructorFlag _) {
+    }
+    public Manager() {
+    }
   }
 
-  [StorableClass]
+  [StorableType("D694E112-47AF-47DF-8A89-F12F95FF43AB")]
   public class C {
     [Storable]
@@ -252,4 +294,10 @@
     [Storable]
     public KeyValuePair<List<C>, C> kvpList;
+
+    [StorableConstructor]
+    protected C(StorableConstructorFlag _) {
+    }
+    public C() {
+    }
   }
 
@@ -486,5 +534,5 @@
     }
 
-    [StorableClass]
+    [StorableType("8EA1D97E-91CD-4643-80B2-D66724E3ED4C")]
     public class NestedType {
       [Storable]
@@ -498,4 +546,10 @@
       public override int GetHashCode() {
         return value.GetHashCode();
+      }
+
+      [StorableConstructor]
+      protected NestedType(StorableConstructorFlag _) {
+      }
+      public NestedType() {
       }
     }
@@ -589,5 +643,5 @@
         new Configuration(new XmlFormat(),
           new List<IPrimitiveSerializer> { new String2XmlSerializer() },
-          new List<ICompositeSerializer> { 
+          new List<ICompositeSerializer> {
             new StorableSerializer(),
             new Number2StringSerializer() }));
@@ -629,16 +683,4 @@
       Assert.AreEqual(newInts[0], newInts[1]);
       Assert.AreNotSame(newInts[0], newInts[1]);
-    }
-
-    [TestMethod]
-    [TestCategory("Persistence")]
-    [TestProperty("Time", "short")]
-    public void NonDefaultConstructorTest() {
-      NonDefaultConstructorClass c = new NonDefaultConstructorClass(1);
-      try {
-        XmlGenerator.Serialize(c, tempFile);
-        Assert.Fail("Exception not thrown");
-      } catch (PersistenceException) {
-      }
     }
 
@@ -753,20 +795,38 @@
     }
 
-    [StorableClass]
+    [StorableType("B7140365-BA53-4E12-A095-86A3AAF5D159")]
     class Child {
       [Storable]
       public GrandParent grandParent;
-    }
-
-    [StorableClass]
+
+      [StorableConstructor]
+      protected Child(StorableConstructorFlag _) {
+      }
+      public Child() {
+      }
+    }
+
+    [StorableType("45FAEF81-D8CD-47DB-B8DD-BBFE81F37181")]
     class Parent {
       [Storable]
       public Child child;
-    }
-
-    [StorableClass]
+
+      [StorableConstructor]
+      protected Parent(StorableConstructorFlag _) {
+      }
+      public Parent() {
+      }
+    }
+
+    [StorableType("0668DB55-89ED-4943-B0AB-245AB3167348")]
     class GrandParent {
       [Storable]
       public Parent parent;
+
+      [StorableConstructor]
+      protected GrandParent(StorableConstructorFlag _) {
+      }
+      public GrandParent() {
+      }
     }
 
@@ -843,5 +903,5 @@
     }
 
-    [StorableClass]
+    [StorableType("92DD18D7-A43C-4DEE-9354-81196F4DC96D")]
     private class PersistenceHooks {
       [Storable]
@@ -858,4 +918,10 @@
       void PostDeserializationHook() {
         sum = a + b;
+      }
+
+      [StorableConstructor]
+      protected PersistenceHooks(StorableConstructorFlag _) {
+      }
+      public PersistenceHooks() {
       }
     }
@@ -880,5 +946,5 @@
     }
 
-    [StorableClass]
+    [StorableType("3E9A9875-875F-41DD-AEEC-2924643C8E45")]
     private class CustomConstructor {
       public string Value = "none";
@@ -887,6 +953,5 @@
       }
       [StorableConstructor]
-      private CustomConstructor(bool deserializing) {
-        Assert.IsTrue(deserializing);
+      private CustomConstructor(StorableConstructorFlag _) {
         Value = "persistence";
       }
@@ -902,27 +967,4 @@
       CustomConstructor newCC = (CustomConstructor)XmlParser.Deserialize(tempFile);
       Assert.AreEqual(newCC.Value, "persistence");
-    }
-
-    [StorableClass]
-    public class ExplodingDefaultConstructor {
-      public ExplodingDefaultConstructor() {
-        throw new Exception("this constructor will always fail");
-      }
-      public ExplodingDefaultConstructor(string password) {
-      }
-    }
-
-    [TestMethod]
-    [TestCategory("Persistence")]
-    [TestProperty("Time", "short")]
-    public void TestConstructorExceptionUnwrapping() {
-      ExplodingDefaultConstructor x = new ExplodingDefaultConstructor("password");
-      XmlGenerator.Serialize(x, tempFile);
-      try {
-        ExplodingDefaultConstructor newX = (ExplodingDefaultConstructor)XmlParser.Deserialize(tempFile);
-        Assert.Fail("Exception expected");
-      } catch (PersistenceException pe) {
-        Assert.AreEqual(pe.InnerException.Message, "this constructor will always fail");
-      }
     }
 
@@ -954,5 +996,5 @@
     }
 
-    [StorableClass]
+    [StorableType("BC0996AA-6544-4D0F-8CBD-1FCCF08F4637")]
     public class HookInheritanceTestBase {
       [Storable]
@@ -963,7 +1005,13 @@
         link = a;
       }
-    }
-
-    [StorableClass]
+
+      [StorableConstructor]
+      protected HookInheritanceTestBase(StorableConstructorFlag _) {
+      }
+      public HookInheritanceTestBase() {
+      }
+    }
+
+    [StorableType("E0CABA1E-EA8E-4B50-9840-1F80D23E8DC7")]
     public class HookInheritanceTestDerivedClass : HookInheritanceTestBase {
       [Storable]
@@ -974,4 +1022,10 @@
         link = b;
       }
+
+      [StorableConstructor]
+      protected HookInheritanceTestDerivedClass(StorableConstructorFlag _) : base(_) {
+      }
+      public HookInheritanceTestDerivedClass() {
+      }
     }
 
@@ -987,5 +1041,5 @@
     }
 
-    [StorableClass(StorableClassType.AllFields)]
+    [StorableType(StorableMemberSelection.AllFields, "45B11367-791E-4967-86AA-D6B83EC3CDAE")]
     public class AllFieldsStorable {
       public int Value1 = 1;
@@ -995,11 +1049,10 @@
       public int Value4 { get; private set; }
       [StorableConstructor]
-      public AllFieldsStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
+      protected AllFieldsStorable(StorableConstructorFlag _) { }
+      public AllFieldsStorable() {
+        Value1 = 12;
+        Value2 = 23;
+        Value3 = 34;
+        Value4 = 56;
       }
     }
@@ -1009,5 +1062,5 @@
     [TestProperty("Time", "short")]
     public void TestStorableClassDiscoveryAllFields() {
-      AllFieldsStorable afs = new AllFieldsStorable(false);
+      AllFieldsStorable afs = new AllFieldsStorable();
       XmlGenerator.Serialize(afs, tempFile);
       AllFieldsStorable newAfs = (AllFieldsStorable)XmlParser.Deserialize(tempFile);
@@ -1018,5 +1071,5 @@
     }
 
-    [StorableClass(StorableClassType.AllProperties)]
+    [StorableType(StorableMemberSelection.AllProperties, "BB7931E4-2900-430C-80FA-1CF3C41BA2C9")]
     public class AllPropertiesStorable {
       public int Value1 = 1;
@@ -1026,11 +1079,10 @@
       public int Value4 { get; private set; }
       [StorableConstructor]
-      public AllPropertiesStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
+      protected AllPropertiesStorable(StorableConstructorFlag _) { }
+      public AllPropertiesStorable() {
+        Value1 = 12;
+        Value2 = 23;
+        Value3 = 34;
+        Value4 = 56;
       }
     }
@@ -1040,5 +1092,5 @@
     [TestProperty("Time", "short")]
     public void TestStorableClassDiscoveryAllProperties() {
-      AllPropertiesStorable afs = new AllPropertiesStorable(false);
+      AllPropertiesStorable afs = new AllPropertiesStorable();
       XmlGenerator.Serialize(afs, tempFile);
       AllPropertiesStorable newAfs = (AllPropertiesStorable)XmlParser.Deserialize(tempFile);
@@ -1050,5 +1102,5 @@
     }
 
-    [StorableClass(StorableClassType.AllFieldsAndAllProperties)]
+    [StorableType(StorableMemberSelection.AllFieldsAndAllProperties, "D81160A5-BCF9-409A-9082-EFB803C882BF")]
     public class AllFieldsAndAllPropertiesStorable {
       public int Value1 = 1;
@@ -1058,11 +1110,10 @@
       public int Value4 { get; private set; }
       [StorableConstructor]
-      public AllFieldsAndAllPropertiesStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
+      protected AllFieldsAndAllPropertiesStorable(StorableConstructorFlag _) { }
+      public AllFieldsAndAllPropertiesStorable() {
+        Value1 = 12;
+        Value2 = 23;
+        Value3 = 34;
+        Value4 = 56;
       }
     }
@@ -1072,5 +1123,5 @@
     [TestProperty("Time", "short")]
     public void TestStorableClassDiscoveryAllFieldsAndAllProperties() {
-      AllFieldsAndAllPropertiesStorable afs = new AllFieldsAndAllPropertiesStorable(false);
+      AllFieldsAndAllPropertiesStorable afs = new AllFieldsAndAllPropertiesStorable();
       XmlGenerator.Serialize(afs, tempFile);
       AllFieldsAndAllPropertiesStorable newAfs = (AllFieldsAndAllPropertiesStorable)XmlParser.Deserialize(tempFile);
@@ -1081,5 +1132,5 @@
     }
 
-    [StorableClass(StorableClassType.MarkedOnly)]
+    [StorableType(StorableMemberSelection.MarkedOnly, "979BEF0C-D150-4809-9EF4-467B7CCB9665")]
     public class MarkedOnlyStorable {
       public int Value1 = 1;
@@ -1089,11 +1140,10 @@
       public int Value4 { get; private set; }
       [StorableConstructor]
-      public MarkedOnlyStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
+      protected MarkedOnlyStorable(StorableConstructorFlag _) { }
+      public MarkedOnlyStorable() {
+        Value1 = 12;
+        Value2 = 23;
+        Value3 = 34;
+        Value4 = 56;
       }
     }
@@ -1103,5 +1153,5 @@
     [TestProperty("Time", "short")]
     public void TestStorableClassDiscoveryMarkedOnly() {
-      MarkedOnlyStorable afs = new MarkedOnlyStorable(false);
+      MarkedOnlyStorable afs = new MarkedOnlyStorable();
       XmlGenerator.Serialize(afs, tempFile);
       MarkedOnlyStorable newAfs = (MarkedOnlyStorable)XmlParser.Deserialize(tempFile);
@@ -1241,9 +1291,15 @@
     }
 
-    [StorableClass]
+    [StorableType("5F96AAB5-F68E-4A41-BA66-E56069822719")]
     public class ReadOnlyFail {
       [Storable]
       public string ReadOnly {
         get { return "fail"; }
+      }
+
+      [StorableConstructor]
+      protected ReadOnlyFail(StorableConstructorFlag _) {
+      }
+      public ReadOnlyFail() {
       }
     }
@@ -1263,9 +1319,15 @@
 
 
-    [StorableClass]
+    [StorableType("9809F12C-B787-4BB5-9930-705673964D45")]
     public class WriteOnlyFail {
       [Storable]
       public string WriteOnly {
         set { throw new InvalidOperationException("this property should never be set."); }
+      }
+
+      [StorableConstructor]
+      protected WriteOnlyFail(StorableConstructorFlag _) {
+      }
+      public WriteOnlyFail() {
       }
     }
@@ -1284,6 +1346,10 @@
     }
 
-    [StorableClass]
+    [StorableType("749C5247-ABB8-4286-8208-058CC7B9C781")]
     public class OneWayTest {
+      [StorableConstructor]
+      protected OneWayTest(StorableConstructorFlag _) {
+      }
+
       public OneWayTest() { this.value = "default"; }
       public string value;
@@ -1309,5 +1375,5 @@
       Assert.AreEqual("ReadOnly", ((PrimitiveToken)it.Current).Name); it.MoveNext();
       Assert.AreEqual("ROOT", ((EndToken)it.Current).Name); it.MoveNext();
-      var deserializer = new Deserializer(new[] { 
+      var deserializer = new Deserializer(new[] {
         new TypeMapping(0, typeof(OneWayTest).AssemblyQualifiedName, typeof(StorableSerializer).AssemblyQualifiedName),
         new TypeMapping(1, typeof(string).AssemblyQualifiedName, typeof(String2XmlSerializer).AssemblyQualifiedName) });
@@ -1461,5 +1527,5 @@
       b[2] = byte.MaxValue;
       XmlGenerator.Serialize(b, tempFile);
-      var newB = (byte[]) XmlParser.Deserialize(tempFile);
+      var newB = (byte[])XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(b, newB);
     }
@@ -1469,7 +1535,7 @@
     [TestProperty("Time", "short")]
     public void TestOptionalNumberEnumerable() {
-      var values = new List<double?> {0, null, double.NaN, double.PositiveInfinity, double.MaxValue, 1};
+      var values = new List<double?> { 0, null, double.NaN, double.PositiveInfinity, double.MaxValue, 1 };
       XmlGenerator.Serialize(values, tempFile);
-      var newValues = (List<double?>) XmlParser.Deserialize(tempFile);
+      var newValues = (List<double?>)XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(values, newValues);
     }
@@ -1482,5 +1548,5 @@
         DateTime.ParseExact("10.09.2014 12:21", "dd.MM.yyyy hh:mm", CultureInfo.InvariantCulture), DateTime.MaxValue};
       XmlGenerator.Serialize(values, tempFile);
-      var newValues = (List<DateTime?>) XmlParser.Deserialize(tempFile);
+      var newValues = (List<DateTime?>)XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(values, newValues);
     }
@@ -1490,7 +1556,7 @@
     [TestProperty("Time", "short")]
     public void TestStringEnumerable() {
-      var values = new List<string> {"", null, "s", "string", string.Empty, "123", "<![CDATA[nice]]>", "<![CDATA[nasty unterminated"};
+      var values = new List<string> { "", null, "s", "string", string.Empty, "123", "<![CDATA[nice]]>", "<![CDATA[nasty unterminated" };
       XmlGenerator.Serialize(values, tempFile);
-      var newValues = (List<String>) XmlParser.Deserialize(tempFile);
+      var newValues = (List<String>)XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(values, newValues);
     }
@@ -1500,5 +1566,5 @@
     [TestProperty("Time", "short")]
     public void TestUnicodeCharArray() {
-      var s = Encoding.UTF8.GetChars(new byte[] {0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb});
+      var s = Encoding.UTF8.GetChars(new byte[] { 0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb });
       XmlGenerator.Serialize(s, tempFile);
       var newS = (char[])XmlParser.Deserialize(tempFile);
@@ -1510,5 +1576,5 @@
     [TestProperty("Time", "short")]
     public void TestUnicode() {
-      var s = Encoding.UTF8.GetString(new byte[] {0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb});
+      var s = Encoding.UTF8.GetString(new byte[] { 0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb });
       XmlGenerator.Serialize(s, tempFile);
       var newS = XmlParser.Deserialize(tempFile);
@@ -1520,5 +1586,5 @@
     [TestProperty("Time", "short")]
     public void TestQueue() {
-      var q = new Queue<int>(new[] {1, 2, 3, 4, 0});
+      var q = new Queue<int>(new[] { 1, 2, 3, 4, 0 });
       XmlGenerator.Serialize(q, tempFile);
       var newQ = (Queue<int>)XmlParser.Deserialize(tempFile);
Index: /branches/2936_GQAPIntegration/HeuristicLab.Tests/HeuristicLab.Persistence.Attic/StorableAttributeTests.cs
===================================================================
--- /branches/2936_GQAPIntegration/HeuristicLab.Tests/HeuristicLab.Persistence.Attic/StorableAttributeTests.cs	(revision 16711)
+++ /branches/2936_GQAPIntegration/HeuristicLab.Tests/HeuristicLab.Persistence.Attic/StorableAttributeTests.cs	(revision 16711)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+
+namespace HeuristicLab.Persistence.Attic.Tests {
+
+  [StorableType("E0862640-FD57-4F1B-929D-03E38D8EA5D3")]
+  class DemoClass {
+
+    [Storable(Name = "TestProperty", DefaultValue = 12)]
+    public object o = null;
+
+    [Storable]
+    public int x = 2;
+
+    public int y = 0;
+
+    [StorableConstructor]
+    protected DemoClass(StorableConstructorFlag _) {
+    }
+    public DemoClass() {
+    }
+  }
+
+  [StorableType("7C5431ED-9754-44B9-870D-F62E822A74CE")]
+  class Base {
+    public string baseName;
+    [Storable]
+    public virtual string Name {
+      get { return "Base"; }
+      set { baseName = value; }
+    }
+
+    [StorableConstructor]
+    protected Base(StorableConstructorFlag _) {
+    }
+    public Base() {
+    }
+  }
+
+  [StorableType("39BC0BDD-C5F4-4FAA-B227-558909E7AE6C")]
+  class Override : Base {
+    [Storable]
+    public override string Name {
+      get { return "Override"; }
+      set { base.Name = value; }
+    }
+
+    [StorableConstructor]
+    protected Override(StorableConstructorFlag _) : base(_) {
+    }
+    public Override() {
+    }
+  }
+
+  [StorableType("50E13067-A343-4059-B44B-54511ED813AE")]
+  class Intermediate : Override {
+    [StorableConstructor]
+    protected Intermediate(StorableConstructorFlag _) : base(_) {
+    }
+    public Intermediate() {
+    }
+  }
+
+  [StorableType("DA7868B2-81CC-48AC-AEC3-2E3AD2E0A34E")]
+  class New : Intermediate {
+    public string newName;
+    [Storable]
+    public new string Name {
+      get { return "New"; }
+      set { newName = value; }
+    }
+
+    [StorableConstructor]
+    protected New(StorableConstructorFlag _) : base(_) {
+    }
+    public New() {
+    }
+  }
+}
